var async = require("async");

var docxReader = require("./lib/docx/docx-reader");

function convertToPlainText(input) {
    return docxReader.read(input)
        .then(function(documentResult) {
            return documentResult.map(convertElementToPlainText);
        });
}

function convertElementToPlainText(element) {
    if (element.type === "text") {
        return element.value;
    } else {
        var tail = element.type === "paragraph" ? "\n\n" : "";
        return (element.children || []).map(convertElementToPlainText).join("") + tail;
    }
}

function convertElements(elements, html, messages, callback) {
    async.eachSeries(elements, function(element, callback) {
        return elementToHtml(element, html, messages, callback);
    }, callback);
}

convertToPlainText({path: process.argv[2]}).then(function(result) {
    console.log(result.value);
});
